using System;
using System.Threading;
using Hardcodet.Scheduling;
using NUnit.Framework;


namespace Scheduling_Tests
{
  /// <summary>
  /// 
  /// </summary>
  [TestFixture]
  public class Given_Job_When_Expired : SchedulerTestBase
  {
    protected override void InitInternal()
    {
      Scheduler.MinJobInterval = 1;
    }



    /// <summary>
    /// 
    /// </summary>
    [Test]
    public void Job_Should_Be_Aborted_After_Expiring()
    {
      Job job = new Job();

      //the job should start immediately and expire in two hours
      job.Run.Every.Seconds(0.1).Until(DateTime.Now.AddHours(2));

      int callbacks = 0;
      Scheduler.SubmitJob(job, (j) => callbacks++);

      Thread.Sleep(450);
      Assert.AreEqual(5, callbacks);

      //lets make the scheduler believe it's 3 hours later now
      SystemTime.Now = () => DateTimeOffset.Now.AddHours(3);

      //the job should not have been executed anymore
      Thread.Sleep(1000);
      Assert.AreEqual(5, callbacks);
      Assert.AreEqual(JobState.Finished, job.State);
    }

  }
}