using System;
using Hardcodet.Scheduling;
using NUnit.Framework;

namespace Scheduling_Tests
{
  public class SchedulerTestBase
  {
    public Scheduler Scheduler { get; set; }

    [SetUp]
    public void Init()
    {
      Scheduler = new Scheduler();
      InitInternal();
    }

    protected virtual void InitInternal()
    {
    }

    [TearDown]
    public void Cleanup()
    {
      CleanupInternal();
      
      if(Scheduler != null) Scheduler.CancelAll();
      SystemTime.Reset();
      
    }

    protected virtual void CleanupInternal()
    {
    }
  }
}