﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using Hardcodet.Scheduling;

namespace Scheduling_Sample
{
	public partial class MainPage : UserControl
	{
		private Scheduler scheduler = new Scheduler();
		
		public MainPage()
		{
			// Required to initialize variables
			InitializeComponent();
		}

		private void schedule1_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			schedule1.IsEnabled = false;
			stop1.IsEnabled = true;
			
			//create job
			Job<int> job = new Job<int>("Job 1");
			job.Data = 0;
			job.Run.Every.Seconds(1);
			
			//submit to scheduler
			scheduler.SubmitJob(job, LogJobExecution);
		}
		
		
		private void stop1_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			scheduler.CancelJob("Job 1");
			schedule1.IsEnabled = true;
			stop1.IsEnabled = false;
		}
		
		
		private void schedule2_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			schedule2.IsEnabled = false;
			stop2.IsEnabled = true;
			
			//create job
			Job<int> job = new Job<int>("Job 2");
			job.Data = 0;
			job.Run.Every.Seconds(2);
			
			//submit to scheduler
			scheduler.SubmitJob(job, LogJobExecution);
		}

		private void stop2_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			scheduler.CancelJob("Job 2");
			schedule2.IsEnabled = true;
			stop2.IsEnabled = false;
		}
		
		
		private void LogJobExecution(Job<int> job, int data)
		{
			job.Data = data + 1;
			string msg = String.Format("'{0}' executed at '{1}',  triggered {2} times.\n", job.JobId, DateTime.Now, job.Data);
			Dispatcher.BeginInvoke(() => this.output.Text += msg);
		}




	}
}